;(function(){
    if(window.DhBridge){
        return;
    }
    var DHBRIDGE_SCHEME = 'https';
    var DHBRIDGE_SCHEME_HOST = '__dhb_queue_message__';
    var messagingIframe;
    messagingIframe = document.createElement('iframe');
    messagingIframe.style.display = 'none';
    messagingIframe.src = DHBRIDGE_SCHEME + '://' + DHBRIDGE_SCHEME_HOST;
    document.documentElement.appendChild(messagingIframe);
    window.DhBridge = {
        callHandler:_callHandler,
        callPlugin:_callPlugin,
        handleMessage:_handleMessage,
        fetchMessageQueue:_fetchMessageQueue,
        callBackQueue:{},
        messageQueue:[],

        registerHandlerMap:{},
        registerHandler:_registerHandler,
        removeHandler:_removeHandler,
        callJsHandler:_callJsHandler
    };

    function _registerHandler(handlerName,handlerFunc){
        window.DhBridge.registerHandlerMap[handlerName] = handlerFunc;
    }

    function _removeHandler(handlerName){
        window.DhBridge.registerHandlerMap[handlerName] = null;
    }
    function _callJsHandler(handlerName,arg){
        var handlerFunc =  window.DhBridge.registerHandlerMap[handlerName];
        if(handlerFunc){
            var result =  handlerFunc(arg);
            return result;
        }
        return 'Error,not find handlerName:'+handlerName;
    }

    function _jsToNative(message){
        var result = false;
        try {
            dh_android_Bridge.dhBridge(message);
            result = true;
        } catch (error) {
            console.log('[_jsToNative] error:'+error);
        }
        try {
            window.webkit.messageHandlers.dhBridge.postMessage(message);
            result = true;
        } catch (error) {
            console.log('[_jsToNative] error:'+error);
        }
        if(!result){
            console.log('ScriptMessageHandler not work, try iframe.src method');
            window.DhBridge.messageQueue.push(message);
            messagingIframe.src = DHBRIDGE_SCHEME + '://' + DHBRIDGE_SCHEME_HOST;
            console.log(window.DhBridge.messageQueue);
            result = true;
        }
        return result;
    }
    
    function _callHandler(handlerName,args,success,fail){
        console.log('[_callHandler] '+handlerName+" " +args);
        var message = {handlerName:handlerName,args:args};
        if(success || fail){
            var callbackId = 'dhbridge_callbackId_'+new Date().getTime();
            window.DhBridge.callBackQueue[callbackId] = {success:success,fail:fail};
            message['callbackId'] = callbackId;
        }
        var result = _jsToNative(JSON.stringify(message));
        if(!result){
            if(fail){
                fail(400,"bad request");
            }
            delete window.DhBridge.callBackQueue[message['callbackId']];
        }
    }
    
    function _callPlugin(pluginName,pluginMethod,args,success,fail){
        var handlerName = {pluginName:pluginName,pluginMethod:pluginMethod};
        _callHandler(handlerName,args,success,fail);
    }
    
    function _handleMessage(message){
        console.log('[_handleMessage] '+message);
        var json = JSON.parse(message);
        var callbackId = json['callbackId'];
        if(callbackId !== undefined){
            var callback = window.DhBridge.callBackQueue[callbackId];
            var code = json['code'];
            if(code === 200){
                callback.success(json['data']);
            }else{
                callback.fail(code,json['data']);
            }
            delete window.DhBridge.callBackQueue[callbackId];
        }
    }
    
    function _fetchMessageQueue() {
        var messageQueueString = JSON.stringify(window.DhBridge.messageQueue);
        console.log('_fetchQueue:' + messageQueueString);
        window.DhBridge.messageQueue = [];
        return messageQueueString;
    }
    
    setTimeout(_clearCacheCallQueue, 0);
    function _clearCacheCallQueue() {
        if(window.cacheCallQueue === undefined){return;}
        var queue = window.cacheCallQueue;
        delete window.cacheCallQueue;
        for (var i=0; i<queue.length; i++) {
            window.DhBridge.callHandler(queue[i].handleName,queue[i].args,queue[i].success,queue[i].fail);
        }
    }
}
)();